import ast
import json

import requests
from common.DButils import DButils

from config import wechaturl, error_answer, file_path


def read_json(file_name):
    path = file_path + "/data/" + file_name
    with open(path, "r", encoding="utf-8") as f:
        data = json.load(f)
        return data


def load_json(file_name, data):
    path = file_path + "/data/" + file_name
    with open(path, "w", encoding="utf-8") as f:
        json.dump(data, f)


# 发送微信消息
def error_message(text, url=wechaturl, mobile_list=16638842134):
    data = {
        "msgtype": "text",
        "text": {
            "content": text,
            "mentioned_mobile_list": [mobile_list]
        }
    }
    requests.post(url, json=data)


# 发送mkdown格式微信消息
def mk_error_message(error_editor, error_answer, message_id, url=wechaturl):
    data = {
        "msgtype": "markdown",
        "markdown": {
            "content": f"ws推送<font color=\"warning\">异常</font>，请相关同事注意。\n>问题编辑:<font color=\"comment\">{error_editor}</font>\n>消息id:<font color=\"comment\">{message_id}</font>\n>返回消息:<font color=\"comment\">{error_answer}</font> "
        }
    }
    requests.post(url, json=data)


def mk_error_aireview_message(error_editor, error_answer, message_id, biz_id, url=wechaturl):
    data = {
        "msgtype": "markdown",
        "markdown": {
            "content": f"ws推送<font color=\"warning\">异常</font>，请相关同事注意。\n>问题编辑:<font color=\"comment\">{error_editor}</font>\n>消息id:<font color=\"comment\">{message_id}</font>\n>返回消息:<font color=\"comment\">{error_answer}</font>\n>biz_id:<font color=\"comment\">{biz_id}</font> ",
            "mentioned_mobile_list": ["16638842134", "@宋鹏博"]
        }
    }
    requests.post(url, json=data)


# 查询ws异常消息
def ws_error(minute, error_answer_list=error_answer):
    print("开始")
    data = DButils().select_sql(
        f"select emp_id,content,id  from aicaptain.message_record mr  WHERE create_time  > NOW() - INTERVAL {minute} minute "
        f"and msg_type != 1 ; ")
    for i in range(len(data)):
        for n in error_answer_list:
            if n in data[i][1]:
                editor = DButils().select_sql(
                    f"select name from aicaptain.job where id= (SELECT job_id  FROM aicaptain.employee  WHERE "
                    f" id= {data[i][0]} ); ")
                if editor[0][0] in ["AI审校团队", "AI预审编辑"]:
                    if "true" or "false" in data[0][1]:
                        dirt = data[0][1].replace("true", "True").replace("false", "False")
                        d = ast.literal_eval(dirt)
                        biz_id = d.get("msgContentList")[1].get("data").get("reviewReportRecordId")
                        mk_error_aireview_message(editor[0][0], n, data[i][2], biz_id)
                else:
                    mk_error_message(editor[0][0], n, data[i][2])
    print("结束")


if __name__ == '__main__':
    error_answer_list = ["无法回答此类问题，请换个话题吧", "二维码创建失败", "意图下发失败", "文件处理失败", "生成失败",
                         "润色任务失败", "网络异常", "获取书评助理结果失败", "审校失败", "图书生成报告失败",
                         "对不起，我暂时无法回答这个问题"]
    data = DButils().select_sql(
        f"select emp_id,content,id  from aicaptain.message_record mr  WHERE id=1900420961792245760 "
        f"and msg_type != 1 ; ")
    print(data)
    for i in range(len(data)):
        for n in error_answer_list:
            if n in data[i][1]:
                editor = DButils().select_sql(
                    f"select name from aicaptain.job where id= (SELECT job_id  FROM aicaptain.employee  WHERE "
                    f" id= {data[i][0]} ); ")
                if editor[0][0] == "AI审校团队" or editor[0][0] == "AI预审编辑":
                    if "true" or "false" in data[0][1]:
                        dirt = data[0][1].replace("true", "True").replace("false", "False")
                        d = ast.literal_eval(dirt)
                        biz_id = d.get("msgContentList")[1].get("data").get("reviewReportRecordId")
